/* GHC_PACKAGES rts-1.0
*/
#include "Stg.h"
#include "Prelude.h"
#include "Rts.h"
#include "RtsFlags.h"
#include "RtsUtils.h"
#include "StgRun.h"
#include "Schedule.h"
#include "Printer.h"
#include "Sanity.h"
#include "STM.h"
#include "Storage.h"
#include "SchedAPI.h"
#include "Timer.h"
#include "Itimer.h"
#include "ProfHeap.h"
#include "LdvProfile.h"
#include "Profiling.h"
#include "Apply.h"

FN_(newByteArrayzh_fast) {
W_ _c3;
W_ _c4;
W_ _c5;
W_ _c7;
FB_
if ((*((P_)(W_)&alloc_blocks)) >= (*((P_)(W_)&alloc_blocks_lim))) goto _cat;
goto _cau;
_cat:
R9.p = (P_)0xffU;
R10.p = (P_)(W_)&newByteArrayzh_fast;
JMP_((W_)&stg_gc_gen_hp);
_cau:
_c3 = (W_)R1.w;
_c4 = ((_c3 + 0x4U) - 0x1U) / 0x4U;
_c5 = ((0x4U + 0x4U) / 0x4U) + _c4;
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_c7 = (W_)allocate(_c5);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
*((P_)(_c7)) = (W_)&stg_ARR_WORDS_info;
*((P_)((_c7 + 0x4U) + 0x0)) = _c4;
Sp[-1] = _c7;
Sp=Sp-1;
JMP_(*((P_)(Sp[1])));
FE_
}


FN_(newPinnedByteArrayzh_fast) {
W_ _ce;
W_ _cf;
W_ _cg;
W_ _ci;
FB_
if ((*((P_)(W_)&alloc_blocks)) >= (*((P_)(W_)&alloc_blocks_lim))) goto _cav;
goto _caw;
_cav:
R9.p = (P_)0xffU;
R10.p = (P_)(W_)&newPinnedByteArrayzh_fast;
JMP_((W_)&stg_gc_gen_hp);
_caw:
_ce = (W_)R1.w;
_cf = ((_ce + 0x4U) - 0x1U) / 0x4U;
_cg = ((0x4U + 0x4U) / 0x4U) + _cf;
if (((0x4U + 0x4U) & 0x7U) != 0x0) goto _cax;
goto _cay;
_cax:
_cg = _cg + 0x1U;
goto _cay;
_cay:
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_ci = (W_)allocatePinned(_cg);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
if (((0x4U + 0x4U) & 0x7U) != 0x0) goto _caz;
goto _caA;
_caz:
_ci = _ci + (0x1U * 0x4U);
goto _caA;
_caA:
*((P_)(_ci)) = (W_)&stg_ARR_WORDS_info;
*((P_)((_ci + 0x4U) + 0x0)) = _cf;
Sp[-1] = _ci;
Sp=Sp-1;
JMP_(*((P_)(Sp[1])));
FE_
}


FN_(newArrayzh_fast) {
W_ _cs;
W_ _ct;
W_ _cw;
W_ _cx;
W_ _cz;
FB_
_cs = (W_)R1.w;
if ((*((P_)(W_)&alloc_blocks)) >= (*((P_)(W_)&alloc_blocks_lim))) goto _caB;
goto _caC;
_caB:
R9.p = (P_)(0xffU ^ (0x1U << 0x1U));
R10.p = (P_)(W_)&newArrayzh_fast;
JMP_((W_)&stg_gc_gen_hp);
_caC:
_ct = ((0x4U + 0x8U) / 0x4U) + _cs;
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_cw = (W_)allocate(_ct);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
*((P_)(_cw)) = (W_)&stg_MUT_ARR_PTRS_info;
*((P_)((_cw + 0x4U) + 0x0)) = _cs;
_cx = (W_)R2.w;
_cz = _cw + (0x4U + 0x8U);
goto _L2A;
_L2A:
if (_cz < (_cw + (_ct * 0x4U))) goto _caD;
goto _caE;
_caD:
*((P_)_cz) = _cx;
_cz = _cz + (0x1U * 0x4U);
goto _L2A;
_caE:
Sp[-1] = _cw;
Sp=Sp-1;
JMP_(*((P_)(Sp[1])));
FE_
}


FN_(unsafeThawArrayzh_fast) {
FB_
*((P_)((W_)R1.w + 0x0)) = (W_)&stg_MUT_ARR_PTRS_info;
if ((*((P_)(((W_)R1.w + 0x4U) + 0x4U))) == 0x0) goto _caF;
goto _caG;
_caF:
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
recordMutable((void *)(W_)R1.w);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
goto _caG;
_caG:
Sp[-1] = (W_)R1.w;
Sp=Sp-1;
JMP_(*((P_)(Sp[1])));
FE_
}


FN_(newMutVarzh_fast) {
W_ _cJ;
FB_
Hp = (P_)((W_)Hp + (0x4U + 0x8U));
if ((W_)Hp > (W_)HpLim) goto _caH;
_cJ = ((W_)Hp - (0x4U + 0x8U)) + (0x1U * 0x4U);
*((P_)(_cJ)) = (W_)&stg_MUT_VAR_info;
*((P_)((_cJ + 0x4U) + 0x0)) = (W_)R1.w;
Sp[-1] = _cJ;
Sp=Sp-1;
JMP_(*((P_)(Sp[1])));
_caH:
HpAlloc = 0x4U + 0x8U;
R9.p = (P_)(0xffU ^ (0x1U << 0x0));
R10.p = (P_)(W_)&newMutVarzh_fast;
JMP_((W_)&stg_gc_gen);
FE_
}


FN_(atomicModifyMutVarzh_fast) {
W_ _cP;
W_ _cQ;
W_ _cS;
W_ _cU;
FB_
Hp = (P_)((W_)Hp + (((0x4U + (0x2U * 0x4U)) + (0x4U + (0x2U * 0x4U))) + (0x4U + (0x2U * 0x4U))));
if ((W_)Hp > (W_)HpLim) goto _caI;
_cP = *((P_)(((W_)R1.w + 0x4U) + 0x0));
_cQ = ((W_)Hp - (0x4U + (0x2U * 0x4U))) + (0x1U * 0x4U);
*((P_)(_cQ)) = (W_)&stg_ap_2_upd_info;
*((P_)(((_cQ + 0x4U) + 0x0) + (0x0 * 0x4U))) = (W_)R2.w;
*((P_)(((_cQ + 0x4U) + 0x0) + (0x1U * 0x4U))) = _cP;
_cS = _cQ - (0x4U + (0x2U * 0x4U));
*((P_)(_cS)) = (W_)&stg_sel_0_upd_info;
*((P_)(((_cS + 0x4U) + 0x0) + (0x0 * 0x4U))) = _cQ;
*((P_)(((W_)R1.w + 0x4U) + 0x0)) = _cS;
_cU = _cS - (0x4U + (0x2U * 0x4U));
*((P_)(_cU)) = (W_)&stg_sel_1_upd_info;
*((P_)(((_cU + 0x4U) + 0x0) + (0x0 * 0x4U))) = _cQ;
Sp[-1] = _cU;
Sp=Sp-1;
JMP_(*((P_)(Sp[1])));
_caI:
HpAlloc = ((0x4U + (0x2U * 0x4U)) + (0x4U + (0x2U * 0x4U))) + (0x4U + (0x2U * 0x4U));
R9.p = (P_)((0xffU ^ (0x1U << 0x0)) & (0xffU ^ (0x1U << 0x1U)));
R10.p = (P_)(W_)&atomicModifyMutVarzh_fast;
JMP_((W_)&stg_gc_gen);
FE_
}


FN_(mkForeignObjzh_fast) {
W_ _cY;
FB_
Hp = (P_)((W_)Hp + (0x4U + 0x4U));
if ((W_)Hp > (W_)HpLim) goto _caJ;
_cY = ((W_)Hp - (0x4U + 0x4U)) + (0x1U * 0x4U);
*((P_)(_cY)) = (W_)&stg_FOREIGN_info;
*((P_)((_cY + 0x4U) + 0x0)) = (W_)R1.w;
Sp[-1] = _cY;
Sp=Sp-1;
JMP_(*((P_)(Sp[1])));
_caJ:
HpAlloc = 0x4U + 0x4U;
R9.p = (P_)0xffU;
R10.p = (P_)(W_)&mkForeignObjzh_fast;
JMP_((W_)&stg_gc_gen);
FE_
}

char stg_weak_msg[] = "New weak pointer at %p\012";


FN_(mkWeakzh_fast) {
W_ _c12;
FB_
if ((W_)R3.w == 0x0) goto _caK;
goto _caL;
_caK:
R3.p = (P_)(W_)&stg_NO_FINALIZER_closure;
goto _caL;
_caL:
Hp = (P_)((W_)Hp + (0x4U + 0x10U));
if ((W_)Hp > (W_)HpLim) goto _caM;
_c12 = ((W_)Hp - (0x4U + 0x10U)) + (0x1U * 0x4U);
*((P_)(_c12)) = (W_)&stg_WEAK_info;
*((P_)((_c12 + 0x4U) + 0x0)) = (W_)R1.w;
*((P_)((_c12 + 0x4U) + 0x4U)) = (W_)R2.w;
*((P_)((_c12 + 0x4U) + 0x8U)) = (W_)R3.w;
*((P_)((_c12 + 0x4U) + 0xcU)) = *((P_)(W_)&weak_ptr_list);
*((P_)(W_)&weak_ptr_list) = _c12;
Sp[-1] = _c12;
Sp=Sp-1;
JMP_(*((P_)(Sp[1])));
_caM:
HpAlloc = 0x4U + 0x10U;
R9.p = (P_)(((0xffU ^ (0x1U << 0x0)) & (0xffU ^ (0x1U << 0x1U))) & (0xffU ^ (0x1U << 0x2U)));
R10.p = (P_)(W_)&mkWeakzh_fast;
JMP_((W_)&stg_gc_gen);
FE_
}


FN_(finalizzeWeakzh_fast) {
W_ _c18;
W_ _c1a;
FB_
_c18 = (W_)R1.w;
if ((*((P_)(_c18 + 0x0))) == (W_)&stg_DEAD_WEAK_info) goto _caN;
goto _caO;
_caN:
Sp[-1] = (W_)&stg_NO_FINALIZER_closure;
Sp[-2] = 0x0;
Sp=Sp-2;
JMP_(*((P_)(Sp[2])));
_caO:
*((P_)(_c18 + 0x0)) = (W_)&stg_DEAD_WEAK_info;
_c1a = *((P_)((_c18 + 0x4U) + 0x8U));
*((P_)((_c18 + 0x4U) + 0x0)) = *((P_)((_c18 + 0x4U) + 0xcU));
if (_c1a == (W_)&stg_NO_FINALIZER_closure) goto _caP;
Sp[-1] = _c1a;
Sp[-2] = 0x1U;
Sp=Sp-2;
JMP_(*((P_)(Sp[2])));
_caP:
Sp[-1] = (W_)&stg_NO_FINALIZER_closure;
Sp[-2] = 0x0;
Sp=Sp-2;
JMP_(*((P_)(Sp[2])));
_caQ:
goto _caQ;
FE_
}


FN_(deRefWeakzh_fast) {
W_ _c1h;
W_ _c1j;
W_ _c1l;
FB_
_c1h = (W_)R1.w;
if ((*((P_)(_c1h + 0x0))) == (W_)&stg_WEAK_info) goto _caR;
_c1j = 0x0;
_c1l=_c1h;
goto _caS;
_caR:
_c1j = 0x1U;
_c1l = *((P_)((_c1h + 0x4U) + 0x4U));
goto _caS;
_caS:
Sp[-1] = _c1l;
Sp[-2] = _c1j;
Sp=Sp-2;
JMP_(*((P_)(Sp[2])));
FE_
}


FN_(int2Integerzh_fast) {
W_ _c1q;
W_ _c1t;
W_ _c1u;
FB_
_c1q = (W_)R1.w;
Hp = (P_)((W_)Hp + ((0x4U + 0x4U) + (0x1U * 0x4U)));
if ((W_)Hp > (W_)HpLim) goto _caT;
_c1t = (W_)Hp - (0x4U + 0x4U);
*((P_)(_c1t)) = (W_)&stg_ARR_WORDS_info;
*((P_)((_c1t + 0x4U) + 0x0)) = 0x1U;
if ((I_)_c1q < (I_)0x0) goto _caU;
if ((I_)_c1q > (I_)0x0) goto _caV;
_c1u = 0x0;
goto _caW;
_caT:
HpAlloc = (0x4U + 0x4U) + (0x1U * 0x4U);
R9.p = (P_)0xffU;
R10.p = (P_)(W_)&int2Integerzh_fast;
JMP_((W_)&stg_gc_gen);
_caV:
_c1u = 0x1U;
*((P_)((W_)Hp + (0x0 * 0x4U))) = _c1q;
goto _caW;
_caW:
goto _caX;
_caU:
_c1u = -((I_)0x1U);
*((P_)((W_)Hp + (0x0 * 0x4U))) = -((I_)_c1q);
goto _caX;
_caX:
Sp[-1] = _c1t;
Sp[-2] = _c1u;
Sp=Sp-2;
JMP_(*((P_)(Sp[2])));
FE_
}


FN_(word2Integerzh_fast) {
W_ _c1C;
W_ _c1F;
W_ _c1G;
FB_
_c1C = (W_)R1.w;
Hp = (P_)((W_)Hp + ((0x4U + 0x4U) + (0x1U * 0x4U)));
if ((W_)Hp > (W_)HpLim) goto _caY;
_c1F = (W_)Hp - (0x4U + 0x4U);
*((P_)(_c1F)) = (W_)&stg_ARR_WORDS_info;
*((P_)((_c1F + 0x4U) + 0x0)) = 0x1U;
if (_c1C != 0x0) goto _caZ;
_c1G = 0x0;
goto _cb0;
_caY:
HpAlloc = (0x4U + 0x4U) + (0x1U * 0x4U);
R9.p = (P_)0xffU;
R10.p = (P_)(W_)&word2Integerzh_fast;
JMP_((W_)&stg_gc_gen);
_caZ:
_c1G = 0x1U;
*Hp = _c1C;
goto _cb0;
_cb0:
Sp[-1] = _c1F;
Sp[-2] = _c1G;
Sp=Sp-2;
JMP_(*((P_)(Sp[2])));
FE_
}


FN_(int64ToIntegerzh_fast) {
StgWord64 _c1M;
W_ _c1Q;
W_ _c1S;
W_ _c1U;
W_ _c1V;
W_ _c1W;
FB_
_c1M=L1;
_c1Q = 0x0;
if ((StgInt64)_c1M >= (StgInt64)0x100000000ULL) goto _cb1;
if ((StgInt64)_c1M <= (StgInt64)(-((StgInt64)0x100000000ULL))) goto _cb1;
_c1S = 0x1U;
goto _cb2;
_cb1:
_c1S = 0x2U;
goto _cb2;
_cb2:
Hp = (P_)((W_)Hp + ((0x4U + 0x4U) + (_c1S * 0x4U)));
if ((W_)Hp > (W_)HpLim) goto _cb3;
_c1U = (((W_)Hp - (0x4U + 0x4U)) - (_c1S * 0x4U)) + (0x1U * 0x4U);
*((P_)(_c1U)) = (W_)&stg_ARR_WORDS_info;
*((P_)((_c1U + 0x4U) + 0x0)) = _c1S;
if ((StgInt64)_c1M < (StgInt64)0x0) goto _cb4;
goto _cb5;
_cb3:
HpAlloc = (0x4U + 0x4U) + (_c1S * 0x4U);
R9.p = (P_)0xffU;
R10.p = (P_)(W_)&int64ToIntegerzh_fast;
JMP_((W_)&stg_gc_gen);
_cb4:
_c1Q = 0x1U;
_c1M = -((StgInt64)_c1M);
goto _cb5;
_cb5:
_c1V = (I_)((StgInt64)(_c1M >> 0x20U));
if (_c1S == 0x2U) goto _cb6;
if (_c1M != 0x0) goto _cb7;
_c1W = 0x0;
goto _cb8;
_cb7:
_c1W = 0x1U;
*((P_)((W_)Hp + (0x0 * 0x4U))) = (I_)((StgInt64)_c1M);
goto _cb8;
_cb8:
goto _cb9;
_cb6:
_c1W = 0x2U;
*((P_)((W_)Hp + ((-((I_)0x1U)) * 0x4U))) = (I_)((StgInt64)_c1M);
*((P_)((W_)Hp + (0x0 * 0x4U))) = _c1V;
goto _cb9;
_cb9:
if (_c1Q != 0x0) goto _cba;
goto _cbb;
_cba:
_c1W = -((I_)_c1W);
goto _cbb;
_cbb:
Sp[-1] = _c1U;
Sp[-2] = _c1W;
Sp=Sp-2;
JMP_(*((P_)(Sp[2])));
FE_
}


FN_(word64ToIntegerzh_fast) {
StgWord64 _c2a;
W_ _c2e;
W_ _c2g;
W_ _c2h;
W_ _c2i;
FB_
_c2a=L1;
if (_c2a >= 0x100000000ULL) goto _cbc;
_c2e = 0x1U;
goto _cbd;
_cbc:
_c2e = 0x2U;
goto _cbd;
_cbd:
Hp = (P_)((W_)Hp + ((0x4U + 0x4U) + (_c2e * 0x4U)));
if ((W_)Hp > (W_)HpLim) goto _cbe;
_c2g = (((W_)Hp - (0x4U + 0x4U)) - (_c2e * 0x4U)) + (0x1U * 0x4U);
*((P_)(_c2g)) = (W_)&stg_ARR_WORDS_info;
*((P_)((_c2g + 0x4U) + 0x0)) = _c2e;
_c2h = (I_)((StgInt64)(_c2a >> 0x20U));
if (_c2a >= 0x100000000ULL) goto _cbf;
if (_c2a != 0x0) goto _cbg;
_c2i = 0x0;
goto _cbh;
_cbe:
HpAlloc = (0x4U + 0x4U) + (_c2e * 0x4U);
R9.p = (P_)0xffU;
R10.p = (P_)(W_)&word64ToIntegerzh_fast;
JMP_((W_)&stg_gc_gen);
_cbg:
_c2i = 0x1U;
*((P_)((W_)Hp + (0x0 * 0x4U))) = (I_)((StgInt64)_c2a);
goto _cbh;
_cbh:
goto _cbi;
_cbf:
_c2i = 0x2U;
*((P_)((W_)Hp + ((-((I_)0x1U)) * 0x4U))) = (I_)((StgInt64)_c2a);
*((P_)((W_)Hp + (0x0 * 0x4U))) = _c2h;
goto _cbi;
_cbi:
Sp[-1] = _c2g;
Sp[-2] = _c2i;
Sp=Sp-2;
JMP_(*((P_)(Sp[2])));
FE_
}

char mp_tmp1[12];

char mp_tmp2[12];

char result1[12];

char result2[12];


FN_(plusIntegerzh_fast) {
W_ _c2s;
W_ _c2v;
W_ _c2w;
W_ _c2y;
FB_
if ((*((P_)(W_)&alloc_blocks)) >= (*((P_)(W_)&alloc_blocks_lim))) goto _cbj;
goto _cbk;
_cbj:
R9.p = (P_)((0xffU ^ (0x1U << 0x1U)) & (0xffU ^ (0x1U << 0x3U)));
R10.p = (P_)(W_)&plusIntegerzh_fast;
JMP_((W_)&stg_gc_gen_hp);
_cbk:
_c2s = (W_)R1.w;
_c2v = (W_)R2.w;
_c2w = (W_)R3.w;
_c2y = (W_)R4.w;
*((P_)((W_)&mp_tmp1 + 0x0)) = *((P_)((_c2v + 0x4U) + 0x0));
*((P_)((W_)&mp_tmp1 + 0x4U)) = _c2s;
*((P_)((W_)&mp_tmp1 + 0x8U)) = _c2v + (0x4U + 0x4U);
*((P_)((W_)&mp_tmp2 + 0x0)) = *((P_)((_c2y + 0x4U) + 0x0));
*((P_)((W_)&mp_tmp2 + 0x4U)) = _c2w;
*((P_)((W_)&mp_tmp2 + 0x8U)) = _c2y + (0x4U + 0x4U);
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_init((void *)(W_)&result1);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_add((void *)(W_)&result1, (void *)(W_)&mp_tmp1, (void *)(W_)&mp_tmp2);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
Sp[-1] = (*((P_)((W_)&result1 + 0x8U))) - (0x4U + 0x4U);
Sp[-2] = ((I_)(*((P_)((W_)&result1 + 0x4U))));
Sp=Sp-2;
JMP_(*((P_)(Sp[2])));
FE_
}


FN_(minusIntegerzh_fast) {
W_ _c2D;
W_ _c2G;
W_ _c2H;
W_ _c2J;
FB_
if ((*((P_)(W_)&alloc_blocks)) >= (*((P_)(W_)&alloc_blocks_lim))) goto _cbl;
goto _cbm;
_cbl:
R9.p = (P_)((0xffU ^ (0x1U << 0x1U)) & (0xffU ^ (0x1U << 0x3U)));
R10.p = (P_)(W_)&minusIntegerzh_fast;
JMP_((W_)&stg_gc_gen_hp);
_cbm:
_c2D = (W_)R1.w;
_c2G = (W_)R2.w;
_c2H = (W_)R3.w;
_c2J = (W_)R4.w;
*((P_)((W_)&mp_tmp1 + 0x0)) = *((P_)((_c2G + 0x4U) + 0x0));
*((P_)((W_)&mp_tmp1 + 0x4U)) = _c2D;
*((P_)((W_)&mp_tmp1 + 0x8U)) = _c2G + (0x4U + 0x4U);
*((P_)((W_)&mp_tmp2 + 0x0)) = *((P_)((_c2J + 0x4U) + 0x0));
*((P_)((W_)&mp_tmp2 + 0x4U)) = _c2H;
*((P_)((W_)&mp_tmp2 + 0x8U)) = _c2J + (0x4U + 0x4U);
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_init((void *)(W_)&result1);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_sub((void *)(W_)&result1, (void *)(W_)&mp_tmp1, (void *)(W_)&mp_tmp2);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
Sp[-1] = (*((P_)((W_)&result1 + 0x8U))) - (0x4U + 0x4U);
Sp[-2] = ((I_)(*((P_)((W_)&result1 + 0x4U))));
Sp=Sp-2;
JMP_(*((P_)(Sp[2])));
FE_
}


FN_(timesIntegerzh_fast) {
W_ _c2O;
W_ _c2R;
W_ _c2S;
W_ _c2U;
FB_
if ((*((P_)(W_)&alloc_blocks)) >= (*((P_)(W_)&alloc_blocks_lim))) goto _cbn;
goto _cbo;
_cbn:
R9.p = (P_)((0xffU ^ (0x1U << 0x1U)) & (0xffU ^ (0x1U << 0x3U)));
R10.p = (P_)(W_)&timesIntegerzh_fast;
JMP_((W_)&stg_gc_gen_hp);
_cbo:
_c2O = (W_)R1.w;
_c2R = (W_)R2.w;
_c2S = (W_)R3.w;
_c2U = (W_)R4.w;
*((P_)((W_)&mp_tmp1 + 0x0)) = *((P_)((_c2R + 0x4U) + 0x0));
*((P_)((W_)&mp_tmp1 + 0x4U)) = _c2O;
*((P_)((W_)&mp_tmp1 + 0x8U)) = _c2R + (0x4U + 0x4U);
*((P_)((W_)&mp_tmp2 + 0x0)) = *((P_)((_c2U + 0x4U) + 0x0));
*((P_)((W_)&mp_tmp2 + 0x4U)) = _c2S;
*((P_)((W_)&mp_tmp2 + 0x8U)) = _c2U + (0x4U + 0x4U);
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_init((void *)(W_)&result1);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_mul((void *)(W_)&result1, (void *)(W_)&mp_tmp1, (void *)(W_)&mp_tmp2);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
Sp[-1] = (*((P_)((W_)&result1 + 0x8U))) - (0x4U + 0x4U);
Sp[-2] = ((I_)(*((P_)((W_)&result1 + 0x4U))));
Sp=Sp-2;
JMP_(*((P_)(Sp[2])));
FE_
}


FN_(gcdIntegerzh_fast) {
W_ _c2Z;
W_ _c32;
W_ _c33;
W_ _c35;
FB_
if ((*((P_)(W_)&alloc_blocks)) >= (*((P_)(W_)&alloc_blocks_lim))) goto _cbp;
goto _cbq;
_cbp:
R9.p = (P_)((0xffU ^ (0x1U << 0x1U)) & (0xffU ^ (0x1U << 0x3U)));
R10.p = (P_)(W_)&gcdIntegerzh_fast;
JMP_((W_)&stg_gc_gen_hp);
_cbq:
_c2Z = (W_)R1.w;
_c32 = (W_)R2.w;
_c33 = (W_)R3.w;
_c35 = (W_)R4.w;
*((P_)((W_)&mp_tmp1 + 0x0)) = *((P_)((_c32 + 0x4U) + 0x0));
*((P_)((W_)&mp_tmp1 + 0x4U)) = _c2Z;
*((P_)((W_)&mp_tmp1 + 0x8U)) = _c32 + (0x4U + 0x4U);
*((P_)((W_)&mp_tmp2 + 0x0)) = *((P_)((_c35 + 0x4U) + 0x0));
*((P_)((W_)&mp_tmp2 + 0x4U)) = _c33;
*((P_)((W_)&mp_tmp2 + 0x8U)) = _c35 + (0x4U + 0x4U);
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_init((void *)(W_)&result1);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_gcd((void *)(W_)&result1, (void *)(W_)&mp_tmp1, (void *)(W_)&mp_tmp2);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
Sp[-1] = (*((P_)((W_)&result1 + 0x8U))) - (0x4U + 0x4U);
Sp[-2] = ((I_)(*((P_)((W_)&result1 + 0x4U))));
Sp=Sp-2;
JMP_(*((P_)(Sp[2])));
FE_
}


FN_(quotIntegerzh_fast) {
W_ _c3a;
W_ _c3d;
W_ _c3e;
W_ _c3g;
FB_
if ((*((P_)(W_)&alloc_blocks)) >= (*((P_)(W_)&alloc_blocks_lim))) goto _cbr;
goto _cbs;
_cbr:
R9.p = (P_)((0xffU ^ (0x1U << 0x1U)) & (0xffU ^ (0x1U << 0x3U)));
R10.p = (P_)(W_)&quotIntegerzh_fast;
JMP_((W_)&stg_gc_gen_hp);
_cbs:
_c3a = (W_)R1.w;
_c3d = (W_)R2.w;
_c3e = (W_)R3.w;
_c3g = (W_)R4.w;
*((P_)((W_)&mp_tmp1 + 0x0)) = *((P_)((_c3d + 0x4U) + 0x0));
*((P_)((W_)&mp_tmp1 + 0x4U)) = _c3a;
*((P_)((W_)&mp_tmp1 + 0x8U)) = _c3d + (0x4U + 0x4U);
*((P_)((W_)&mp_tmp2 + 0x0)) = *((P_)((_c3g + 0x4U) + 0x0));
*((P_)((W_)&mp_tmp2 + 0x4U)) = _c3e;
*((P_)((W_)&mp_tmp2 + 0x8U)) = _c3g + (0x4U + 0x4U);
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_init((void *)(W_)&result1);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_tdiv_q((void *)(W_)&result1, (void *)(W_)&mp_tmp1, (void *)(W_)&mp_tmp2);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
Sp[-1] = (*((P_)((W_)&result1 + 0x8U))) - (0x4U + 0x4U);
Sp[-2] = ((I_)(*((P_)((W_)&result1 + 0x4U))));
Sp=Sp-2;
JMP_(*((P_)(Sp[2])));
FE_
}


FN_(remIntegerzh_fast) {
W_ _c3l;
W_ _c3o;
W_ _c3p;
W_ _c3r;
FB_
if ((*((P_)(W_)&alloc_blocks)) >= (*((P_)(W_)&alloc_blocks_lim))) goto _cbt;
goto _cbu;
_cbt:
R9.p = (P_)((0xffU ^ (0x1U << 0x1U)) & (0xffU ^ (0x1U << 0x3U)));
R10.p = (P_)(W_)&remIntegerzh_fast;
JMP_((W_)&stg_gc_gen_hp);
_cbu:
_c3l = (W_)R1.w;
_c3o = (W_)R2.w;
_c3p = (W_)R3.w;
_c3r = (W_)R4.w;
*((P_)((W_)&mp_tmp1 + 0x0)) = *((P_)((_c3o + 0x4U) + 0x0));
*((P_)((W_)&mp_tmp1 + 0x4U)) = _c3l;
*((P_)((W_)&mp_tmp1 + 0x8U)) = _c3o + (0x4U + 0x4U);
*((P_)((W_)&mp_tmp2 + 0x0)) = *((P_)((_c3r + 0x4U) + 0x0));
*((P_)((W_)&mp_tmp2 + 0x4U)) = _c3p;
*((P_)((W_)&mp_tmp2 + 0x8U)) = _c3r + (0x4U + 0x4U);
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_init((void *)(W_)&result1);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_tdiv_r((void *)(W_)&result1, (void *)(W_)&mp_tmp1, (void *)(W_)&mp_tmp2);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
Sp[-1] = (*((P_)((W_)&result1 + 0x8U))) - (0x4U + 0x4U);
Sp[-2] = ((I_)(*((P_)((W_)&result1 + 0x4U))));
Sp=Sp-2;
JMP_(*((P_)(Sp[2])));
FE_
}


FN_(divExactIntegerzh_fast) {
W_ _c3w;
W_ _c3z;
W_ _c3A;
W_ _c3C;
FB_
if ((*((P_)(W_)&alloc_blocks)) >= (*((P_)(W_)&alloc_blocks_lim))) goto _cbv;
goto _cbw;
_cbv:
R9.p = (P_)((0xffU ^ (0x1U << 0x1U)) & (0xffU ^ (0x1U << 0x3U)));
R10.p = (P_)(W_)&divExactIntegerzh_fast;
JMP_((W_)&stg_gc_gen_hp);
_cbw:
_c3w = (W_)R1.w;
_c3z = (W_)R2.w;
_c3A = (W_)R3.w;
_c3C = (W_)R4.w;
*((P_)((W_)&mp_tmp1 + 0x0)) = *((P_)((_c3z + 0x4U) + 0x0));
*((P_)((W_)&mp_tmp1 + 0x4U)) = _c3w;
*((P_)((W_)&mp_tmp1 + 0x8U)) = _c3z + (0x4U + 0x4U);
*((P_)((W_)&mp_tmp2 + 0x0)) = *((P_)((_c3C + 0x4U) + 0x0));
*((P_)((W_)&mp_tmp2 + 0x4U)) = _c3A;
*((P_)((W_)&mp_tmp2 + 0x8U)) = _c3C + (0x4U + 0x4U);
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_init((void *)(W_)&result1);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_divexact((void *)(W_)&result1, (void *)(W_)&mp_tmp1, (void *)(W_)&mp_tmp2);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
Sp[-1] = (*((P_)((W_)&result1 + 0x8U))) - (0x4U + 0x4U);
Sp[-2] = ((I_)(*((P_)((W_)&result1 + 0x4U))));
Sp=Sp-2;
JMP_(*((P_)(Sp[2])));
FE_
}


FN_(andIntegerzh_fast) {
W_ _c3H;
W_ _c3K;
W_ _c3L;
W_ _c3N;
FB_
if ((*((P_)(W_)&alloc_blocks)) >= (*((P_)(W_)&alloc_blocks_lim))) goto _cbx;
goto _cby;
_cbx:
R9.p = (P_)((0xffU ^ (0x1U << 0x1U)) & (0xffU ^ (0x1U << 0x3U)));
R10.p = (P_)(W_)&andIntegerzh_fast;
JMP_((W_)&stg_gc_gen_hp);
_cby:
_c3H = (W_)R1.w;
_c3K = (W_)R2.w;
_c3L = (W_)R3.w;
_c3N = (W_)R4.w;
*((P_)((W_)&mp_tmp1 + 0x0)) = *((P_)((_c3K + 0x4U) + 0x0));
*((P_)((W_)&mp_tmp1 + 0x4U)) = _c3H;
*((P_)((W_)&mp_tmp1 + 0x8U)) = _c3K + (0x4U + 0x4U);
*((P_)((W_)&mp_tmp2 + 0x0)) = *((P_)((_c3N + 0x4U) + 0x0));
*((P_)((W_)&mp_tmp2 + 0x4U)) = _c3L;
*((P_)((W_)&mp_tmp2 + 0x8U)) = _c3N + (0x4U + 0x4U);
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_init((void *)(W_)&result1);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_and((void *)(W_)&result1, (void *)(W_)&mp_tmp1, (void *)(W_)&mp_tmp2);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
Sp[-1] = (*((P_)((W_)&result1 + 0x8U))) - (0x4U + 0x4U);
Sp[-2] = ((I_)(*((P_)((W_)&result1 + 0x4U))));
Sp=Sp-2;
JMP_(*((P_)(Sp[2])));
FE_
}


FN_(orIntegerzh_fast) {
W_ _c3S;
W_ _c3V;
W_ _c3W;
W_ _c3Y;
FB_
if ((*((P_)(W_)&alloc_blocks)) >= (*((P_)(W_)&alloc_blocks_lim))) goto _cbz;
goto _cbA;
_cbz:
R9.p = (P_)((0xffU ^ (0x1U << 0x1U)) & (0xffU ^ (0x1U << 0x3U)));
R10.p = (P_)(W_)&orIntegerzh_fast;
JMP_((W_)&stg_gc_gen_hp);
_cbA:
_c3S = (W_)R1.w;
_c3V = (W_)R2.w;
_c3W = (W_)R3.w;
_c3Y = (W_)R4.w;
*((P_)((W_)&mp_tmp1 + 0x0)) = *((P_)((_c3V + 0x4U) + 0x0));
*((P_)((W_)&mp_tmp1 + 0x4U)) = _c3S;
*((P_)((W_)&mp_tmp1 + 0x8U)) = _c3V + (0x4U + 0x4U);
*((P_)((W_)&mp_tmp2 + 0x0)) = *((P_)((_c3Y + 0x4U) + 0x0));
*((P_)((W_)&mp_tmp2 + 0x4U)) = _c3W;
*((P_)((W_)&mp_tmp2 + 0x8U)) = _c3Y + (0x4U + 0x4U);
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_init((void *)(W_)&result1);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_ior((void *)(W_)&result1, (void *)(W_)&mp_tmp1, (void *)(W_)&mp_tmp2);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
Sp[-1] = (*((P_)((W_)&result1 + 0x8U))) - (0x4U + 0x4U);
Sp[-2] = ((I_)(*((P_)((W_)&result1 + 0x4U))));
Sp=Sp-2;
JMP_(*((P_)(Sp[2])));
FE_
}


FN_(xorIntegerzh_fast) {
W_ _c43;
W_ _c46;
W_ _c47;
W_ _c49;
FB_
if ((*((P_)(W_)&alloc_blocks)) >= (*((P_)(W_)&alloc_blocks_lim))) goto _cbB;
goto _cbC;
_cbB:
R9.p = (P_)((0xffU ^ (0x1U << 0x1U)) & (0xffU ^ (0x1U << 0x3U)));
R10.p = (P_)(W_)&xorIntegerzh_fast;
JMP_((W_)&stg_gc_gen_hp);
_cbC:
_c43 = (W_)R1.w;
_c46 = (W_)R2.w;
_c47 = (W_)R3.w;
_c49 = (W_)R4.w;
*((P_)((W_)&mp_tmp1 + 0x0)) = *((P_)((_c46 + 0x4U) + 0x0));
*((P_)((W_)&mp_tmp1 + 0x4U)) = _c43;
*((P_)((W_)&mp_tmp1 + 0x8U)) = _c46 + (0x4U + 0x4U);
*((P_)((W_)&mp_tmp2 + 0x0)) = *((P_)((_c49 + 0x4U) + 0x0));
*((P_)((W_)&mp_tmp2 + 0x4U)) = _c47;
*((P_)((W_)&mp_tmp2 + 0x8U)) = _c49 + (0x4U + 0x4U);
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_init((void *)(W_)&result1);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_xor((void *)(W_)&result1, (void *)(W_)&mp_tmp1, (void *)(W_)&mp_tmp2);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
Sp[-1] = (*((P_)((W_)&result1 + 0x8U))) - (0x4U + 0x4U);
Sp[-2] = ((I_)(*((P_)((W_)&result1 + 0x4U))));
Sp=Sp-2;
JMP_(*((P_)(Sp[2])));
FE_
}


FN_(complementIntegerzh_fast) {
W_ _c4f;
W_ _c4g;
FB_
if ((*((P_)(W_)&alloc_blocks)) >= (*((P_)(W_)&alloc_blocks_lim))) goto _cbD;
goto _cbE;
_cbD:
R9.p = (P_)(0xffU ^ (0x1U << 0x1U));
R10.p = (P_)(W_)&complementIntegerzh_fast;
JMP_((W_)&stg_gc_gen_hp);
_cbE:
_c4f = (W_)R2.w;
_c4g = (W_)R1.w;
*((P_)((W_)&mp_tmp1 + 0x0)) = *((P_)((_c4f + 0x4U) + 0x0));
*((P_)((W_)&mp_tmp1 + 0x4U)) = _c4g;
*((P_)((W_)&mp_tmp1 + 0x8U)) = _c4f + (0x4U + 0x4U);
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_init((void *)(W_)&result1);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_com((void *)(W_)&result1, (void *)(W_)&mp_tmp1);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
Sp[-1] = (*((P_)((W_)&result1 + 0x8U))) - (0x4U + 0x4U);
Sp[-2] = ((I_)(*((P_)((W_)&result1 + 0x4U))));
Sp=Sp-2;
JMP_(*((P_)(Sp[2])));
FE_
}


FN_(quotRemIntegerzh_fast) {
W_ _c4l;
W_ _c4o;
W_ _c4p;
W_ _c4r;
FB_
if ((*((P_)(W_)&alloc_blocks)) >= (*((P_)(W_)&alloc_blocks_lim))) goto _cbF;
goto _cbG;
_cbF:
R9.p = (P_)((0xffU ^ (0x1U << 0x1U)) & (0xffU ^ (0x1U << 0x3U)));
R10.p = (P_)(W_)&quotRemIntegerzh_fast;
JMP_((W_)&stg_gc_gen_hp);
_cbG:
_c4l = (W_)R1.w;
_c4o = (W_)R2.w;
_c4p = (W_)R3.w;
_c4r = (W_)R4.w;
*((P_)((W_)&mp_tmp1 + 0x0)) = *((P_)((_c4o + 0x4U) + 0x0));
*((P_)((W_)&mp_tmp1 + 0x4U)) = _c4l;
*((P_)((W_)&mp_tmp1 + 0x8U)) = _c4o + (0x4U + 0x4U);
*((P_)((W_)&mp_tmp2 + 0x0)) = *((P_)((_c4r + 0x4U) + 0x0));
*((P_)((W_)&mp_tmp2 + 0x4U)) = _c4p;
*((P_)((W_)&mp_tmp2 + 0x8U)) = _c4r + (0x4U + 0x4U);
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_init((void *)(W_)&result1);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_init((void *)(W_)&result2);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_tdiv_qr((void *)(W_)&result1, (void *)(W_)&result2, (void *)(W_)&mp_tmp1, (void *)(W_)&mp_tmp2);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
Sp[-2] = (*((P_)((W_)&result1 + 0x8U))) - (0x4U + 0x4U);
Sp[-1] = (*((P_)((W_)&result2 + 0x8U))) - (0x4U + 0x4U);
Sp[-4] = ((I_)(*((P_)((W_)&result1 + 0x4U))));
Sp[-3] = ((I_)(*((P_)((W_)&result2 + 0x4U))));
Sp=Sp-4;
JMP_(*((P_)(Sp[4])));
FE_
}


FN_(divModIntegerzh_fast) {
W_ _c4w;
W_ _c4z;
W_ _c4A;
W_ _c4C;
FB_
if ((*((P_)(W_)&alloc_blocks)) >= (*((P_)(W_)&alloc_blocks_lim))) goto _cbH;
goto _cbI;
_cbH:
R9.p = (P_)((0xffU ^ (0x1U << 0x1U)) & (0xffU ^ (0x1U << 0x3U)));
R10.p = (P_)(W_)&divModIntegerzh_fast;
JMP_((W_)&stg_gc_gen_hp);
_cbI:
_c4w = (W_)R1.w;
_c4z = (W_)R2.w;
_c4A = (W_)R3.w;
_c4C = (W_)R4.w;
*((P_)((W_)&mp_tmp1 + 0x0)) = *((P_)((_c4z + 0x4U) + 0x0));
*((P_)((W_)&mp_tmp1 + 0x4U)) = _c4w;
*((P_)((W_)&mp_tmp1 + 0x8U)) = _c4z + (0x4U + 0x4U);
*((P_)((W_)&mp_tmp2 + 0x0)) = *((P_)((_c4C + 0x4U) + 0x0));
*((P_)((W_)&mp_tmp2 + 0x4U)) = _c4A;
*((P_)((W_)&mp_tmp2 + 0x8U)) = _c4C + (0x4U + 0x4U);
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_init((void *)(W_)&result1);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_init((void *)(W_)&result2);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
mpz_fdiv_qr((void *)(W_)&result1, (void *)(W_)&result2, (void *)(W_)&mp_tmp1, (void *)(W_)&mp_tmp2);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
Sp[-2] = (*((P_)((W_)&result1 + 0x8U))) - (0x4U + 0x4U);
Sp[-1] = (*((P_)((W_)&result2 + 0x8U))) - (0x4U + 0x4U);
Sp[-4] = ((I_)(*((P_)((W_)&result1 + 0x4U))));
Sp[-3] = ((I_)(*((P_)((W_)&result2 + 0x4U))));
Sp=Sp-4;
JMP_(*((P_)(Sp[4])));
FE_
}

char aa[4];


FN_(gcdIntzh_fast) {
W_ _c4H;
FB_
*((P_)(W_)&aa) = (W_)R1.w;
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_c4H = mpn_gcd_1((void *)(W_)&aa, 0x1U, (W_)R2.w);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
R1.p = (P_)_c4H;
JMP_(*((P_)(*((P_)((W_)Sp + (0x0 * 0x4U))))));
FE_
}


FN_(gcdIntegerIntzh_fast) {
FB_
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
R1.w = mpn_gcd_1((void *)((W_)R2.w + (0x4U + 0x4U)), (W_)R1.w, (W_)R3.w);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
JMP_(*((P_)(*((P_)((W_)Sp + (0x0 * 0x4U))))));
FE_
}


FN_(cmpIntegerIntzh_fast) {
W_ _c4L;
W_ _c4N;
W_ _c4P;
W_ _c4R;
FB_
_c4L = (W_)R1.w;
_c4N = 0x0;
_c4P = (W_)R3.w;
if ((I_)_c4P > (I_)0x0) goto _cbJ;
if ((I_)_c4P < (I_)0x0) goto _cbK;
goto _cbL;
_cbK:
_c4N = -((I_)0x1U);
_c4P = -((I_)_c4P);
goto _cbL;
_cbL:
goto _cbM;
_cbJ:
_c4N = 0x1U;
goto _cbM;
_cbM:
if (_c4L != _c4N) goto _cbN;
goto _cbO;
_cbN:
R1.p = (P_)(_c4L - _c4N);
JMP_(*((P_)(*((P_)((W_)Sp + (0x0 * 0x4U))))));
_cbO:
if (_c4L == 0x0) goto _cbP;
goto _cbQ;
_cbP:
R1.p = (P_)0x0;
JMP_(*((P_)(*((P_)((W_)Sp + (0x0 * 0x4U))))));
_cbQ:
_c4R = *((P_)((W_)R2.w + (0x4U + 0x4U)));
if (_c4R == _c4P) goto _cbR;
goto _cbS;
_cbR:
R1.p = (P_)0x0;
JMP_(*((P_)(*((P_)((W_)Sp + (0x0 * 0x4U))))));
_cbS:
if (_c4R > _c4P) goto _cbT;
R1.p = (P_)(-((I_)_c4L));
goto _cbU;
_cbT:
R1.p = (P_)_c4L;
goto _cbU;
_cbU:
JMP_(*((P_)(*((P_)((W_)Sp + (0x0 * 0x4U))))));
FE_
}


FN_(cmpIntegerzh_fast) {
W_ _c56;
W_ _c58;
W_ _c5a;
W_ _c5c;
W_ _c5e;
W_ _c5g;
FB_
_c56 = (W_)R1.w;
_c58 = (W_)R3.w;
if (_c56 != _c58) goto _cbV;
goto _cbW;
_cbV:
R1.p = (P_)(_c56 - _c58);
JMP_(*((P_)(*((P_)((W_)Sp + (0x0 * 0x4U))))));
_cbW:
if (_c56 == 0x0) goto _cbX;
goto _cbY;
_cbX:
R1.p = (P_)0x0;
JMP_(*((P_)(*((P_)((W_)Sp + (0x0 * 0x4U))))));
_cbY:
if ((I_)_c56 < (I_)0x0) goto _cbZ;
_c5a=_c56;
goto _cc0;
_cbZ:
_c5a = -((I_)_c56);
goto _cc0;
_cc0:
_c5c = (W_)R2.w + (0x4U + 0x4U);
_c5e = (W_)R4.w + (0x4U + 0x4U);
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_c5g = mpn_cmp((void *)_c5c, (void *)_c5e, _c5a);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
if (_c5g == 0x0) goto _cc1;
goto _cc2;
_cc1:
R1.p = (P_)0x0;
JMP_(*((P_)(*((P_)((W_)Sp + (0x0 * 0x4U))))));
_cc2:
if (((I_)_c5g < (I_)0x0) == ((I_)_c56 < (I_)0x0)) goto _cc3;
R1.p = (P_)(-((I_)0x1U));
goto _cc4;
_cc3:
R1.p = (P_)0x1U;
goto _cc4;
_cc4:
JMP_(*((P_)(*((P_)((W_)Sp + (0x0 * 0x4U))))));
FE_
}


FN_(integer2Intzh_fast) {
W_ _c5u;
W_ _c5v;
FB_
_c5u = (W_)R1.w;
if (_c5u == 0x0) goto _cc5;
_c5v = *((P_)((W_)R2.w + (0x4U + 0x4U)));
if ((I_)_c5u < (I_)0x0) goto _cc6;
goto _cc7;
_cc6:
_c5v = -((I_)_c5v);
goto _cc7;
_cc7:
goto _cc8;
_cc5:
_c5v = 0x0;
goto _cc8;
_cc8:
R1.p = (P_)_c5v;
JMP_(*((P_)(*((P_)((W_)Sp + (0x0 * 0x4U))))));
FE_
}


FN_(integer2Wordzh_fast) {
W_ _c5D;
W_ _c5E;
FB_
_c5D = (W_)R1.w;
if (_c5D == 0x0) goto _cc9;
_c5E = *((P_)((W_)R2.w + (0x4U + 0x4U)));
if ((I_)_c5D < (I_)0x0) goto _cca;
goto _ccb;
_cca:
_c5E = -((I_)_c5E);
goto _ccb;
_ccb:
goto _ccc;
_cc9:
_c5E = 0x0;
goto _ccc;
_ccc:
R1.p = (P_)_c5E;
JMP_(*((P_)(*((P_)((W_)Sp + (0x0 * 0x4U))))));
FE_
}

char exponent[4];


FN_(decodeFloatzh_fast) {
StgFloat _c5M;
W_ _c5N;
FB_
_c5M=F1;
Hp = (P_)((W_)Hp + ((0x4U + 0x4U) + (0x1U * 0x4U)));
if ((W_)Hp > (W_)HpLim) goto _ccd;
_c5N = (W_)Hp - (0x4U + 0x4U);
*((P_)(_c5N)) = (W_)&stg_ARR_WORDS_info;
*((P_)((_c5N + 0x4U) + 0x0)) = 0x1U;
*((P_)((W_)&mp_tmp1 + 0x8U)) = _c5N + (0x4U + 0x4U);
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
__decodeFloat((void *)(W_)&mp_tmp1, (void *)(W_)&exponent, _c5M);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
Sp[-1] = _c5N;
Sp[-3] = *((P_)(W_)&exponent);
Sp[-2] = ((I_)(*((P_)((W_)&mp_tmp1 + 0x4U))));
Sp=Sp-3;
JMP_(*((P_)(Sp[3])));
_ccd:
HpAlloc = (0x4U + 0x4U) + (0x1U * 0x4U);
R9.p = (P_)0xffU;
R10.p = (P_)(W_)&decodeFloatzh_fast;
JMP_((W_)&stg_gc_gen);
FE_
}


FN_(decodeDoublezh_fast) {
StgDouble _c5R;
W_ _c5T;
FB_
_c5R=D1;
Hp = (P_)((W_)Hp + ((0x4U + 0x4U) + 0x8U));
if ((W_)Hp > (W_)HpLim) goto _cce;
_c5T = ((W_)Hp - ((0x4U + 0x4U) + 0x8U)) + (0x1U * 0x4U);
*((P_)(_c5T)) = (W_)&stg_ARR_WORDS_info;
*((P_)((_c5T + 0x4U) + 0x0)) = 0x8U / 0x4U;
*((P_)((W_)&mp_tmp1 + 0x8U)) = _c5T + (0x4U + 0x4U);
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
__decodeDouble((void *)(W_)&mp_tmp1, (void *)(W_)&exponent, _c5R);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
Sp[-1] = _c5T;
Sp[-3] = *((P_)(W_)&exponent);
Sp[-2] = ((I_)(*((P_)((W_)&mp_tmp1 + 0x4U))));
Sp=Sp-3;
JMP_(*((P_)(Sp[3])));
_cce:
HpAlloc = (0x4U + 0x4U) + 0x8U;
R9.p = (P_)0xffU;
R10.p = (P_)(W_)&decodeDoublezh_fast;
JMP_((W_)&stg_gc_gen);
FE_
}


FN_(forkzh_fast) {
FB_
if ((*((P_)(W_)&alloc_blocks)) >= (*((P_)(W_)&alloc_blocks_lim))) goto _ccf;
goto _ccg;
_ccf:
R9.p = (P_)(0xffU ^ (0x1U << 0x0));
R10.p = (P_)(W_)&forkzh_fast;
JMP_((W_)&stg_gc_gen_hp);
_ccg:
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
R1.w = (W_)createIOThread(*((P_)((W_)&RtsFlags + 0xcU)), (void *)(W_)R1.w);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
scheduleThread((void *)(W_)R1.w);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
*((P_)(W_)&context_switch) = 0x1U;
Sp[-1] = (W_)R1.w;
Sp=Sp-1;
JMP_(*((P_)(Sp[1])));
FE_
}


FN_(yieldzh_fast) {
FB_
JMP_((W_)&stg_yield_noregs);
FE_
}


FN_(myThreadIdzh_fast) {
FB_
Sp[-1] = (W_)CurrentTSO;
Sp=Sp-1;
JMP_(*((P_)(Sp[1])));
FE_
}


FN_(labelThreadzh_fast) {
FB_
JMP_(*((P_)(*((P_)((W_)Sp + (0x0 * 0x4U))))));
FE_
}


FN_(isCurrentThreadBoundzh_fast) {
W_ _cch;
FB_
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_cch = isThreadBound((void *)(W_)CurrentTSO);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
Sp[-1] = _cch;
Sp=Sp-1;
JMP_(*((P_)(Sp[1])));
FE_
}

static char cci_str[] = "catch_retry_frame incorrectly entered!";


FN_(stg_catch_retry_frame_0_ret) {
FB_
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
barf((void *)(W_)&cci_str);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
FE_
}

static char ccj_str[] = "catch_retry_frame incorrectly entered!";


FN_(stg_catch_retry_frame_1_ret) {
FB_
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
barf((void *)(W_)&ccj_str);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
FE_
}

static char cck_str[] = "catch_retry_frame incorrectly entered!";


FN_(stg_catch_retry_frame_2_ret) {
FB_
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
barf((void *)(W_)&cck_str);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
FE_
}

static char ccl_str[] = "catch_retry_frame incorrectly entered!";


FN_(stg_catch_retry_frame_3_ret) {
FB_
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
barf((void *)(W_)&ccl_str);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
FE_
}

static char ccm_str[] = "catch_retry_frame incorrectly entered!";


FN_(stg_catch_retry_frame_4_ret) {
FB_
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
barf((void *)(W_)&ccm_str);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
FE_
}

static char ccn_str[] = "catch_retry_frame incorrectly entered!";


FN_(stg_catch_retry_frame_5_ret) {
FB_
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
barf((void *)(W_)&ccn_str);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
FE_
}

static char cco_str[] = "catch_retry_frame incorrectly entered!";


FN_(stg_catch_retry_frame_6_ret) {
FB_
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
barf((void *)(W_)&cco_str);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
FE_
}

static char ccp_str[] = "catch_retry_frame incorrectly entered!";


FN_(stg_catch_retry_frame_7_ret) {
FB_
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
barf((void *)(W_)&ccp_str);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
FE_
}

StgWord stg_catch_retry_frame_info[] = {
(W_)&stg_catch_retry_frame_ret, 0x24U, 0x47U, 0x0, (W_)&stg_catch_retry_frame_0_ret, (W_)&stg_catch_retry_frame_1_ret, (W_)&stg_catch_retry_frame_2_ret, (W_)&stg_catch_retry_frame_3_ret, (W_)&stg_catch_retry_frame_4_ret, (W_)&stg_catch_retry_frame_5_ret, (W_)&stg_catch_retry_frame_6_ret, (W_)&stg_catch_retry_frame_7_ret
};


FN_(stg_catch_retry_frame_ret) {
W_ _c6p;
W_ _c6q;
W_ _c6r;
W_ _c6v;
W_ _c6w;
W_ _ccq;
FB_
_c6p = *((P_)((W_)Sp + (0x0 * 0x4U)));
Sp = (P_)((W_)Sp + (0x1U * 0x4U));
_c6q = (W_)Sp;
_c6r = *((P_)(((W_)CurrentTSO + 0x4U) + 0x24U));
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_c6w = (W_)stmGetEnclosingTRec((void *)_c6r);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_ccq = stmCommitTransaction((void *)_c6r);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
if (_ccq) goto _ccr;
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_c6v = (W_)stmStartTransaction((void *)_c6w);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
*((P_)(((W_)CurrentTSO + 0x4U) + 0x24U)) = _c6v;
if (*((P_)((_c6q + 0x4U) + 0x0))) goto _ccs;
R1.p = (P_)(*((P_)((_c6q + 0x4U) + 0x4U)));
*((P_)((_c6q + 0x4U) + 0xcU)) = _c6v;
goto _cct;
_ccs:
R1.p = (P_)(*((P_)((_c6q + 0x4U) + 0x8U)));
goto _cct;
_cct:
Sp = (P_)((W_)Sp + ((-((I_)0x1U)) * 0x4U));
JMP_((W_)&stg_ap_v_ret);
_ccr:
*((P_)(((W_)CurrentTSO + 0x4U) + 0x24U)) = _c6w;
Sp = (P_)((W_)Sp + (0x4U + 0x10U));
Sp = (P_)((W_)Sp + ((-((I_)0x1U)) * 0x4U));
*((P_)((W_)Sp + (0x0 * 0x4U))) = _c6p;
JMP_(*((P_)(*((P_)((W_)Sp + (0x1U * 0x4U))))));
_ccu:
goto _ccu;
FE_
}

static char ccv_str[] = "atomically_frame incorrectly entered!";


FN_(stg_atomically_frame_0_ret) {
FB_
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
barf((void *)(W_)&ccv_str);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
FE_
}

static char ccw_str[] = "atomically_frame incorrectly entered!";


FN_(stg_atomically_frame_1_ret) {
FB_
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
barf((void *)(W_)&ccw_str);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
FE_
}

static char ccx_str[] = "atomically_frame incorrectly entered!";


FN_(stg_atomically_frame_2_ret) {
FB_
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
barf((void *)(W_)&ccx_str);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
FE_
}

static char ccy_str[] = "atomically_frame incorrectly entered!";


FN_(stg_atomically_frame_3_ret) {
FB_
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
barf((void *)(W_)&ccy_str);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
FE_
}

static char ccz_str[] = "atomically_frame incorrectly entered!";


FN_(stg_atomically_frame_4_ret) {
FB_
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
barf((void *)(W_)&ccz_str);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
FE_
}

static char ccA_str[] = "atomically_frame incorrectly entered!";


FN_(stg_atomically_frame_5_ret) {
FB_
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
barf((void *)(W_)&ccA_str);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
FE_
}

static char ccB_str[] = "atomically_frame incorrectly entered!";


FN_(stg_atomically_frame_6_ret) {
FB_
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
barf((void *)(W_)&ccB_str);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
FE_
}

static char ccC_str[] = "atomically_frame incorrectly entered!";


FN_(stg_atomically_frame_7_ret) {
FB_
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
barf((void *)(W_)&ccC_str);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
FE_
}

StgWord stg_atomically_frame_info[] = {
(W_)&stg_atomically_frame_ret, 0x22U, 0x46U, 0x0, (W_)&stg_atomically_frame_0_ret, (W_)&stg_atomically_frame_1_ret, (W_)&stg_atomically_frame_2_ret, (W_)&stg_atomically_frame_3_ret, (W_)&stg_atomically_frame_4_ret, (W_)&stg_atomically_frame_5_ret, (W_)&stg_atomically_frame_6_ret, (W_)&stg_atomically_frame_7_ret
};


FN_(stg_atomically_frame_ret) {
W_ _c6U;
W_ _c6V;
W_ _c6W;
W_ _ccD;
FB_
_c6U = *((P_)((W_)Sp + (0x0 * 0x4U)));
Sp = (P_)((W_)Sp + (0x1U * 0x4U));
_c6V = (W_)Sp;
_c6W = *((P_)(((W_)CurrentTSO + 0x4U) + 0x24U));
if (*((P_)((_c6V + 0x4U) + 0x0))) goto _ccE;
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_ccD = stmCommitTransaction((void *)_c6W);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
if (_ccD) goto _ccF;
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_c6W = (W_)stmStartTransaction((void *)(W_)&NO_TREC);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
*((P_)(((W_)CurrentTSO + 0x4U) + 0x24U)) = _c6W;
R1.p = (P_)(*((P_)((_c6V + 0x4U) + 0x4U)));
Sp = (P_)((W_)Sp + ((-((I_)0x1U)) * 0x4U));
JMP_((W_)&stg_ap_v_ret);
_ccF:
*((P_)(((W_)CurrentTSO + 0x4U) + 0x24U)) = (W_)&NO_TREC;
Sp = (P_)((W_)Sp + (0x4U + 0x8U));
Sp = (P_)((W_)Sp + ((-((I_)0x1U)) * 0x4U));
*((P_)((W_)Sp + (0x0 * 0x4U))) = _c6U;
JMP_(*((P_)(*((P_)((W_)Sp + (0x1U * 0x4U))))));
_ccG:
goto _ccH;
_ccE:
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_ccD = stmReWait((void *)(W_)CurrentTSO);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
if (_ccD) goto _ccI;
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_c6W = (W_)stmStartTransaction((void *)(W_)&NO_TREC);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
*((P_)(((W_)CurrentTSO + 0x4U) + 0x24U)) = _c6W;
*((P_)((_c6V + 0x4U) + 0x0)) = 0x0;
R1.p = (P_)(*((P_)((_c6V + 0x4U) + 0x4U)));
Sp = (P_)((W_)Sp + ((-((I_)0x1U)) * 0x4U));
JMP_((W_)&stg_ap_v_ret);
_ccI:
Sp = (P_)((W_)Sp + ((-((I_)0x2U)) * 0x4U));
*((P_)((W_)Sp + (0x1U * 0x4U))) = (W_)&stg_NO_FINALIZER_closure;
*((P_)((W_)Sp + (0x0 * 0x4U))) = (W_)&stg_ut_1_0_unreg_info;
JMP_((W_)&stg_block_noregs);
_ccH:
goto _ccH;
FE_
}


FN_(stg_catch_stm_frame_0_ret) {
W_ _c75;
FB_
_c75 = *((P_)((W_)Sp + (0x0 * 0x4U)));
Sp = (P_)((W_)Sp + (0x1U * 0x4U));
Sp = (P_)((W_)Sp + (0x4U + 0x4U));
Sp = (P_)((W_)Sp + ((-((I_)0x1U)) * 0x4U));
*((P_)((W_)Sp + (0x0 * 0x4U))) = _c75;
JMP_(*((P_)((*((P_)((W_)Sp + (0x1U * 0x4U)))) + 0x10U)));
FE_
}


FN_(stg_catch_stm_frame_1_ret) {
W_ _c78;
FB_
_c78 = *((P_)((W_)Sp + (0x0 * 0x4U)));
Sp = (P_)((W_)Sp + (0x1U * 0x4U));
Sp = (P_)((W_)Sp + (0x4U + 0x4U));
Sp = (P_)((W_)Sp + ((-((I_)0x1U)) * 0x4U));
*((P_)((W_)Sp + (0x0 * 0x4U))) = _c78;
JMP_(*((P_)((*((P_)((W_)Sp + (0x1U * 0x4U)))) + 0x14U)));
FE_
}


FN_(stg_catch_stm_frame_2_ret) {
W_ _c7b;
FB_
_c7b = *((P_)((W_)Sp + (0x0 * 0x4U)));
Sp = (P_)((W_)Sp + (0x1U * 0x4U));
Sp = (P_)((W_)Sp + (0x4U + 0x4U));
Sp = (P_)((W_)Sp + ((-((I_)0x1U)) * 0x4U));
*((P_)((W_)Sp + (0x0 * 0x4U))) = _c7b;
JMP_(*((P_)((*((P_)((W_)Sp + (0x1U * 0x4U)))) + 0x18U)));
FE_
}


FN_(stg_catch_stm_frame_3_ret) {
W_ _c7e;
FB_
_c7e = *((P_)((W_)Sp + (0x0 * 0x4U)));
Sp = (P_)((W_)Sp + (0x1U * 0x4U));
Sp = (P_)((W_)Sp + (0x4U + 0x4U));
Sp = (P_)((W_)Sp + ((-((I_)0x1U)) * 0x4U));
*((P_)((W_)Sp + (0x0 * 0x4U))) = _c7e;
JMP_(*((P_)((*((P_)((W_)Sp + (0x1U * 0x4U)))) + 0x1cU)));
FE_
}


FN_(stg_catch_stm_frame_4_ret) {
W_ _c7h;
FB_
_c7h = *((P_)((W_)Sp + (0x0 * 0x4U)));
Sp = (P_)((W_)Sp + (0x1U * 0x4U));
Sp = (P_)((W_)Sp + (0x4U + 0x4U));
Sp = (P_)((W_)Sp + ((-((I_)0x1U)) * 0x4U));
*((P_)((W_)Sp + (0x0 * 0x4U))) = _c7h;
JMP_(*((P_)((*((P_)((W_)Sp + (0x1U * 0x4U)))) + 0x20U)));
FE_
}


FN_(stg_catch_stm_frame_5_ret) {
W_ _c7k;
FB_
_c7k = *((P_)((W_)Sp + (0x0 * 0x4U)));
Sp = (P_)((W_)Sp + (0x1U * 0x4U));
Sp = (P_)((W_)Sp + (0x4U + 0x4U));
Sp = (P_)((W_)Sp + ((-((I_)0x1U)) * 0x4U));
*((P_)((W_)Sp + (0x0 * 0x4U))) = _c7k;
JMP_(*((P_)((*((P_)((W_)Sp + (0x1U * 0x4U)))) + 0x24U)));
FE_
}


FN_(stg_catch_stm_frame_6_ret) {
W_ _c7n;
FB_
_c7n = *((P_)((W_)Sp + (0x0 * 0x4U)));
Sp = (P_)((W_)Sp + (0x1U * 0x4U));
Sp = (P_)((W_)Sp + (0x4U + 0x4U));
Sp = (P_)((W_)Sp + ((-((I_)0x1U)) * 0x4U));
*((P_)((W_)Sp + (0x0 * 0x4U))) = _c7n;
JMP_(*((P_)((*((P_)((W_)Sp + (0x1U * 0x4U)))) + 0x28U)));
FE_
}


FN_(stg_catch_stm_frame_7_ret) {
W_ _c7q;
FB_
_c7q = *((P_)((W_)Sp + (0x0 * 0x4U)));
Sp = (P_)((W_)Sp + (0x1U * 0x4U));
Sp = (P_)((W_)Sp + (0x4U + 0x4U));
Sp = (P_)((W_)Sp + ((-((I_)0x1U)) * 0x4U));
*((P_)((W_)Sp + (0x0 * 0x4U))) = _c7q;
JMP_(*((P_)((*((P_)((W_)Sp + (0x1U * 0x4U)))) + 0x2cU)));
FE_
}

StgWord stg_catch_stm_frame_info[] = {
(W_)&stg_catch_stm_frame_ret, 0x1U, 0x48U, 0x0, (W_)&stg_catch_stm_frame_0_ret, (W_)&stg_catch_stm_frame_1_ret, (W_)&stg_catch_stm_frame_2_ret, (W_)&stg_catch_stm_frame_3_ret, (W_)&stg_catch_stm_frame_4_ret, (W_)&stg_catch_stm_frame_5_ret, (W_)&stg_catch_stm_frame_6_ret, (W_)&stg_catch_stm_frame_7_ret
};


FN_(stg_catch_stm_frame_ret) {
W_ _c7t;
FB_
_c7t = *((P_)((W_)Sp + (0x0 * 0x4U)));
Sp = (P_)((W_)Sp + (0x1U * 0x4U));
Sp = (P_)((W_)Sp + (0x4U + 0x4U));
Sp = (P_)((W_)Sp + ((-((I_)0x1U)) * 0x4U));
*((P_)((W_)Sp + (0x0 * 0x4U))) = _c7t;
JMP_(*((P_)(*((P_)((W_)Sp + (0x1U * 0x4U))))));
FE_
}


FN_(atomicallyzh_fast) {
W_ _c7x;
W_ _c7y;
W_ _c7A;
FB_
if (((W_)Sp - ((0x4U + 0x8U) + (0x1U * 0x4U))) < (W_)SpLim) goto _ccK;
_c7x = *((P_)(((W_)CurrentTSO + 0x4U) + 0x24U));
if (_c7x != (W_)&NO_TREC) goto _ccL;
goto _ccM;
_ccK:
R9.p = (P_)(0xffU ^ (0x1U << 0x0));
R10.p = (P_)(W_)&atomicallyzh_fast;
JMP_((W_)&stg_gc_gen);
_ccL:
R1.p = (P_)(W_)&GHCziIOBase_NestedAtomically_closure;
JMP_((W_)&raisezh_fast);
_ccM:
Sp = (P_)((W_)Sp - (0x4U + 0x8U));
_c7y = (W_)Sp;
*((P_)(_c7y)) = (W_)&stg_atomically_frame_info;
*((P_)((_c7y + 0x4U) + 0x0)) = 0x0;
*((P_)((_c7y + 0x4U) + 0x4U)) = (W_)R1.w;
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_c7A = (W_)stmStartTransaction((void *)_c7x);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
*((P_)(((W_)CurrentTSO + 0x4U) + 0x24U)) = _c7A;
Sp = (P_)((W_)Sp + ((-((I_)0x1U)) * 0x4U));
JMP_((W_)&stg_ap_v_ret);
FE_
}


FN_(catchSTMzh_fast) {
W_ _c7G;
FB_
if (((W_)Sp - ((0x4U + 0x4U) + (0x1U * 0x4U))) < (W_)SpLim) goto _ccN;
Sp = (P_)((W_)Sp - (0x4U + 0x4U));
_c7G = (W_)Sp;
*((P_)(_c7G)) = (W_)&stg_catch_stm_frame_info;
*((P_)((_c7G + 0x4U) + 0x0)) = (W_)R2.w;
Sp = (P_)((W_)Sp + ((-((I_)0x1U)) * 0x4U));
JMP_((W_)&stg_ap_v_ret);
_ccN:
R9.p = (P_)((0xffU ^ (0x1U << 0x0)) & (0xffU ^ (0x1U << 0x1U)));
R10.p = (P_)(W_)&catchSTMzh_fast;
JMP_((W_)&stg_gc_gen);
FE_
}


FN_(catchRetryzh_fast) {
W_ _c7M;
W_ _c7N;
W_ _c7O;
FB_
if (((W_)Sp - ((0x4U + 0x10U) + (0x1U * 0x4U))) < (W_)SpLim) goto _ccO;
_c7M = *((P_)(((W_)CurrentTSO + 0x4U) + 0x24U));
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_c7N = (W_)stmStartTransaction((void *)_c7M);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
*((P_)(((W_)CurrentTSO + 0x4U) + 0x24U)) = _c7N;
Sp = (P_)((W_)Sp - (0x4U + 0x10U));
_c7O = (W_)Sp;
*((P_)(_c7O)) = (W_)&stg_catch_retry_frame_info;
*((P_)((_c7O + 0x4U) + 0x0)) = 0x0;
*((P_)((_c7O + 0x4U) + 0x4U)) = (W_)R1.w;
*((P_)((_c7O + 0x4U) + 0x8U)) = (W_)R2.w;
*((P_)((_c7O + 0x4U) + 0xcU)) = _c7N;
Sp = (P_)((W_)Sp + ((-((I_)0x1U)) * 0x4U));
JMP_((W_)&stg_ap_v_ret);
_ccO:
R9.p = (P_)((0xffU ^ (0x1U << 0x0)) & (0xffU ^ (0x1U << 0x1U)));
R10.p = (P_)(W_)&catchRetryzh_fast;
JMP_((W_)&stg_gc_gen);
FE_
}


FN_(retryzh_fast) {
W_ _c7U;
W_ _c7V;
W_ _c7W;
W_ _c87;
W_ _c88;
W_ _ccP;
FB_
if ((*((P_)(W_)&alloc_blocks)) >= (*((P_)(W_)&alloc_blocks_lim))) goto _ccQ;
goto _ccR;
_ccQ:
R9.p = (P_)0xffU;
R10.p = (P_)(W_)&retryzh_fast;
JMP_((W_)&stg_gc_gen_hp);
_ccR:
goto _L65;
_L65:
_c7U = *((P_)(((W_)CurrentTSO + 0x4U) + 0x24U));
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_c88 = (W_)stmGetEnclosingTRec((void *)_c7U);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
*((P_)((W_)CurrentTSO + (((((0x4U + 0x0) + 0x0) + 0x0) + 0x0) + 0x30U))) = (W_)Sp;
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_c7W = findRetryFrameHelper((void *)(W_)CurrentTSO);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
Sp = (P_)(*((P_)((W_)CurrentTSO + (((((0x4U + 0x0) + 0x0) + 0x0) + 0x0) + 0x30U))));
_c7V = (W_)Sp;
if (_c7W == 0x47U) goto _ccS;
goto _ccT;
_ccS:
if (*((P_)((_c7V + 0x4U) + 0x0))) goto _ccU;
goto _ccV;
_ccU:
_c87 = *((P_)((_c7V + 0x4U) + 0xcU));
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_ccP = stmMergeForWaiting((void *)_c7U, (void *)_c87);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
if (_ccP) goto _ccW;
goto _ccX;
_ccW:
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_ccP = stmCommitTransaction((void *)_c7U);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
goto _ccX;
_ccX:
if (_ccP) goto _ccY;
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_c7U = (W_)stmStartTransaction((void *)_c88);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
*((P_)((_c7V + 0x4U) + 0xcU)) = _c7U;
*((P_)((_c7V + 0x4U) + 0x0)) = 0x0;
*((P_)(((W_)CurrentTSO + 0x4U) + 0x24U)) = _c7U;
R1.p = (P_)(*((P_)((_c7V + 0x4U) + 0x4U)));
Sp = (P_)((W_)Sp + ((-((I_)0x1U)) * 0x4U));
JMP_((W_)&stg_ap_v_ret);
_ccY:
*((P_)(((W_)CurrentTSO + 0x4U) + 0x24U)) = _c88;
Sp = (P_)((W_)Sp + (0x4U + 0x10U));
goto _L65;
_ccZ:
goto _cd0;
_ccV:
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_c7U = (W_)stmStartTransaction((void *)_c88);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
*((P_)(((W_)CurrentTSO + 0x4U) + 0x24U)) = _c7U;
*((P_)((_c7V + 0x4U) + 0x0)) = 0x1U;
R1.p = (P_)(*((P_)((_c7V + 0x4U) + 0x8U)));
Sp = (P_)((W_)Sp + ((-((I_)0x1U)) * 0x4U));
JMP_((W_)&stg_ap_v_ret);
_cd0:
goto _ccT;
_ccT:
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_ccP = stmWait((void *)(W_)CurrentTSO, (void *)_c7U);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
if (_ccP) goto _cd1;
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_c7U = (W_)stmStartTransaction((void *)_c88);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
*((P_)(((W_)CurrentTSO + 0x4U) + 0x24U)) = _c7U;
R1.p = (P_)(*((P_)((_c7V + 0x4U) + 0x4U)));
Sp = (P_)_c7V;
Sp = (P_)((W_)Sp + ((-((I_)0x1U)) * 0x4U));
JMP_((W_)&stg_ap_v_ret);
_cd1:
*((P_)((_c7V + 0x4U) + 0x0)) = 0x1U;
Sp = (P_)_c7V;
Sp = (P_)((W_)Sp + ((-((I_)0x2U)) * 0x4U));
*((P_)((W_)Sp + (0x1U * 0x4U))) = (W_)&stg_NO_FINALIZER_closure;
*((P_)((W_)Sp + (0x0 * 0x4U))) = (W_)&stg_ut_1_0_unreg_info;
JMP_((W_)&stg_block_noregs);
_cd2:
goto _cd2;
FE_
}


FN_(newTVarzh_fast) {
W_ _c8h;
FB_
Hp = (P_)((W_)Hp + (0x4U + 0xcU));
if ((W_)Hp > (W_)HpLim) goto _cd3;
_c8h = ((W_)Hp - (0x4U + 0xcU)) + (0x1U * 0x4U);
*((P_)(_c8h)) = (W_)&stg_TVAR_info;
*((P_)((_c8h + 0x4U) + 0x0)) = (W_)R1.w;
*((P_)((_c8h + 0x4U) + 0x8U)) = (W_)&stg_END_STM_WAIT_QUEUE_closure;
Sp[-1] = _c8h;
Sp=Sp-1;
JMP_(*((P_)(Sp[1])));
_cd3:
HpAlloc = 0x4U + 0xcU;
R9.p = (P_)(0xffU ^ (0x1U << 0x0));
R10.p = (P_)(W_)&newTVarzh_fast;
JMP_((W_)&stg_gc_gen);
FE_
}


FN_(readTVarzh_fast) {
W_ _c8l;
W_ _c8n;
W_ _cd4;
FB_
if ((*((P_)(W_)&alloc_blocks)) >= (*((P_)(W_)&alloc_blocks_lim))) goto _cd5;
goto _cd6;
_cd5:
R9.p = (P_)(0xffU ^ (0x1U << 0x0));
R10.p = (P_)(W_)&readTVarzh_fast;
JMP_((W_)&stg_gc_gen_hp);
_cd6:
_c8l = *((P_)(((W_)CurrentTSO + 0x4U) + 0x24U));
_c8n = (W_)R1.w;
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_cd4 = (W_)stmReadTVar((void *)_c8l, (void *)_c8n);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
Sp[-1] = _cd4;
Sp=Sp-1;
JMP_(*((P_)(Sp[1])));
FE_
}


FN_(writeTVarzh_fast) {
W_ _c8t;
W_ _c8v;
W_ _c8x;
FB_
if ((*((P_)(W_)&alloc_blocks)) >= (*((P_)(W_)&alloc_blocks_lim))) goto _cd7;
goto _cd8;
_cd7:
R9.p = (P_)((0xffU ^ (0x1U << 0x0)) & (0xffU ^ (0x1U << 0x1U)));
R10.p = (P_)(W_)&writeTVarzh_fast;
JMP_((W_)&stg_gc_gen_hp);
_cd8:
_c8t = *((P_)(((W_)CurrentTSO + 0x4U) + 0x24U));
_c8v = (W_)R1.w;
_c8x = (W_)R2.w;
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
stmWriteTVar((void *)_c8t, (void *)_c8v, (void *)_c8x);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
JMP_(*((P_)(*((P_)((W_)Sp + (0x0 * 0x4U))))));
FE_
}


FN_(isEmptyMVarzh_fast) {
FB_
if ((*((P_)((W_)R1.w + 0x0))) == (W_)&stg_EMPTY_MVAR_info) goto _cd9;
Sp[-1] = 0x0;
Sp=Sp-1;
JMP_(*((P_)(Sp[1])));
_cd9:
Sp[-1] = 0x1U;
Sp=Sp-1;
JMP_(*((P_)(Sp[1])));
_cda:
goto _cda;
FE_
}


FN_(newMVarzh_fast) {
W_ _c8F;
FB_
Hp = (P_)((W_)Hp + (0x4U + 0x10U));
if ((W_)Hp > (W_)HpLim) goto _cdb;
_c8F = ((W_)Hp - (0x4U + 0x10U)) + (0x1U * 0x4U);
*((P_)(_c8F)) = (W_)&stg_EMPTY_MVAR_info;
*((P_)((_c8F + 0x4U) + 0x0)) = (W_)&stg_END_TSO_QUEUE_closure;
*((P_)((_c8F + 0x4U) + 0x8U)) = (W_)&stg_END_TSO_QUEUE_closure;
*((P_)((_c8F + 0x4U) + 0xcU)) = (W_)&stg_END_TSO_QUEUE_closure;
Sp[-1] = _c8F;
Sp=Sp-1;
JMP_(*((P_)(Sp[1])));
_cdb:
HpAlloc = 0x4U + 0x10U;
R9.p = (P_)0xffU;
R10.p = (P_)(W_)&newMVarzh_fast;
JMP_((W_)&stg_gc_gen);
FE_
}


FN_(takeMVarzh_fast) {
W_ _c8J;
W_ _c8M;
W_ _c8N;
W_ _c8P;
FB_
_c8J = (W_)R1.w;
_c8M = *((P_)(_c8J + 0x0));
if (_c8M == (W_)&stg_EMPTY_MVAR_info) goto _cdc;
goto _cdd;
_cdc:
if ((*((P_)((_c8J + 0x4U) + 0x0))) == (W_)&stg_END_TSO_QUEUE_closure) goto _cde;
*((P_)(((*((P_)((_c8J + 0x4U) + 0x8U))) + 0x4U) + 0x0)) = (W_)CurrentTSO;
goto _cdf;
_cde:
*((P_)((_c8J + 0x4U) + 0x0)) = (W_)CurrentTSO;
goto _cdf;
_cdf:
*((P_)(((W_)CurrentTSO + 0x4U) + 0x0)) = (W_)&stg_END_TSO_QUEUE_closure;
*((StgWord16*)(((W_)CurrentTSO + 0x4U) + 0xeU)) = 0x1U;
*((P_)(((W_)CurrentTSO + 0x4U) + 0x10U)) = _c8J;
*((P_)((_c8J + 0x4U) + 0x8U)) = (W_)CurrentTSO;
JMP_((W_)&stg_block_takemvar);
_cdd:
_c8N = *((P_)((_c8J + 0x4U) + 0xcU));
if ((*((P_)((_c8J + 0x4U) + 0x0))) != (W_)&stg_END_TSO_QUEUE_closure) goto _cdg;
*((P_)(_c8J + 0x0)) = (W_)&stg_EMPTY_MVAR_info;
*((P_)((_c8J + 0x4U) + 0xcU)) = (W_)&stg_END_TSO_QUEUE_closure;
Sp[-1] = _c8N;
Sp=Sp-1;
JMP_(*((P_)(Sp[1])));
_cdg:
_c8P = *((P_)((_c8J + 0x4U) + 0x0));
*((P_)(_c8P + (((((0x4U + 0x0) + 0x0) + 0x0) + 0x0) + 0x30U))) = (*((P_)(_c8P + (((((0x4U + 0x0) + 0x0) + 0x0) + 0x0) + 0x30U)))) + (0x3U * 0x4U);
*((P_)((_c8J + 0x4U) + 0xcU)) = *((P_)((*((P_)(_c8P + (((((0x4U + 0x0) + 0x0) + 0x0) + 0x0) + 0x30U)))) - (0x1U * 0x4U)));
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_c8P = (W_)unblockOne((void *)(*((P_)((_c8J + 0x4U) + 0x0))));
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
*((P_)((_c8J + 0x4U) + 0x0)) = _c8P;
if ((*((P_)((_c8J + 0x4U) + 0x0))) == (W_)&stg_END_TSO_QUEUE_closure) goto _cdh;
goto _cdi;
_cdh:
*((P_)((_c8J + 0x4U) + 0x8U)) = (W_)&stg_END_TSO_QUEUE_closure;
goto _cdi;
_cdi:
Sp[-1] = _c8N;
Sp=Sp-1;
JMP_(*((P_)(Sp[1])));
_cdj:
goto _cdj;
FE_
}


FN_(tryTakeMVarzh_fast) {
W_ _c90;
W_ _c93;
W_ _c94;
W_ _c96;
FB_
_c90 = (W_)R1.w;
_c93 = *((P_)(_c90 + 0x0));
if (_c93 == (W_)&stg_EMPTY_MVAR_info) goto _cdk;
goto _cdl;
_cdk:
Sp[-1] = (W_)&stg_NO_FINALIZER_closure;
Sp[-2] = 0x0;
Sp=Sp-2;
JMP_(*((P_)(Sp[2])));
_cdl:
_c94 = *((P_)((_c90 + 0x4U) + 0xcU));
if ((*((P_)((_c90 + 0x4U) + 0x0))) != (W_)&stg_END_TSO_QUEUE_closure) goto _cdm;
*((P_)((_c90 + 0x4U) + 0xcU)) = (W_)&stg_END_TSO_QUEUE_closure;
*((P_)(_c90 + 0x0)) = (W_)&stg_EMPTY_MVAR_info;
goto _cdn;
_cdm:
_c96 = *((P_)((_c90 + 0x4U) + 0x0));
*((P_)(_c96 + (((((0x4U + 0x0) + 0x0) + 0x0) + 0x0) + 0x30U))) = (*((P_)(_c96 + (((((0x4U + 0x0) + 0x0) + 0x0) + 0x0) + 0x30U)))) + (0x3U * 0x4U);
*((P_)((_c90 + 0x4U) + 0xcU)) = *((P_)((*((P_)(_c96 + (((((0x4U + 0x0) + 0x0) + 0x0) + 0x0) + 0x30U)))) - (0x1U * 0x4U)));
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_c96 = (W_)unblockOne((void *)(*((P_)((_c90 + 0x4U) + 0x0))));
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
*((P_)((_c90 + 0x4U) + 0x0)) = _c96;
if ((*((P_)((_c90 + 0x4U) + 0x0))) == (W_)&stg_END_TSO_QUEUE_closure) goto _cdo;
goto _cdp;
_cdo:
*((P_)((_c90 + 0x4U) + 0x8U)) = (W_)&stg_END_TSO_QUEUE_closure;
goto _cdp;
_cdp:
goto _cdn;
_cdn:
Sp[-1] = _c94;
Sp[-2] = 0x1U;
Sp=Sp-2;
JMP_(*((P_)(Sp[2])));
FE_
}


FN_(putMVarzh_fast) {
W_ _c9f;
W_ _c9h;
W_ _c9j;
FB_
_c9f = (W_)R1.w;
_c9h = *((P_)(_c9f + 0x0));
if (_c9h == (W_)&stg_FULL_MVAR_info) goto _cdq;
goto _cdr;
_cdq:
if ((*((P_)((_c9f + 0x4U) + 0x0))) == (W_)&stg_END_TSO_QUEUE_closure) goto _cds;
*((P_)(((*((P_)((_c9f + 0x4U) + 0x8U))) + 0x4U) + 0x0)) = (W_)CurrentTSO;
goto _cdt;
_cds:
*((P_)((_c9f + 0x4U) + 0x0)) = (W_)CurrentTSO;
goto _cdt;
_cdt:
*((P_)(((W_)CurrentTSO + 0x4U) + 0x0)) = (W_)&stg_END_TSO_QUEUE_closure;
*((StgWord16*)(((W_)CurrentTSO + 0x4U) + 0xeU)) = 0x1U;
*((P_)(((W_)CurrentTSO + 0x4U) + 0x10U)) = _c9f;
*((P_)((_c9f + 0x4U) + 0x8U)) = (W_)CurrentTSO;
JMP_((W_)&stg_block_putmvar);
_cdr:
if ((*((P_)((_c9f + 0x4U) + 0x0))) != (W_)&stg_END_TSO_QUEUE_closure) goto _cdu;
*((P_)((_c9f + 0x4U) + 0xcU)) = (W_)R2.w;
*((P_)(_c9f + 0x0)) = (W_)&stg_FULL_MVAR_info;
JMP_(*((P_)(*((P_)((W_)Sp + (0x0 * 0x4U))))));
_cdu:
_c9j = *((P_)((_c9f + 0x4U) + 0x0));
*((P_)((*((P_)(_c9j + (((((0x4U + 0x0) + 0x0) + 0x0) + 0x0) + 0x30U)))) + (0x1U * 0x4U))) = (W_)R2.w;
*((P_)((*((P_)(_c9j + (((((0x4U + 0x0) + 0x0) + 0x0) + 0x0) + 0x30U)))) + (0x0 * 0x4U))) = (W_)&stg_ut_1_0_unreg_info;
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_c9j = (W_)unblockOne((void *)(*((P_)((_c9f + 0x4U) + 0x0))));
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
*((P_)((_c9f + 0x4U) + 0x0)) = _c9j;
if ((*((P_)((_c9f + 0x4U) + 0x0))) == (W_)&stg_END_TSO_QUEUE_closure) goto _cdv;
goto _cdw;
_cdv:
*((P_)((_c9f + 0x4U) + 0x8U)) = (W_)&stg_END_TSO_QUEUE_closure;
goto _cdw;
_cdw:
JMP_(*((P_)(*((P_)((W_)Sp + (0x0 * 0x4U))))));
_cdx:
goto _cdx;
FE_
}


FN_(tryPutMVarzh_fast) {
W_ _c9u;
W_ _c9w;
W_ _c9y;
FB_
_c9u = (W_)R1.w;
_c9w = *((P_)(_c9u + 0x0));
if (_c9w == (W_)&stg_FULL_MVAR_info) goto _cdy;
goto _cdz;
_cdy:
Sp[-1] = 0x0;
Sp=Sp-1;
JMP_(*((P_)(Sp[1])));
_cdz:
if ((*((P_)((_c9u + 0x4U) + 0x0))) != (W_)&stg_END_TSO_QUEUE_closure) goto _cdA;
*((P_)((_c9u + 0x4U) + 0xcU)) = (W_)R2.w;
*((P_)(_c9u + 0x0)) = (W_)&stg_FULL_MVAR_info;
goto _cdB;
_cdA:
_c9y = *((P_)((_c9u + 0x4U) + 0x0));
*((P_)((*((P_)(_c9y + (((((0x4U + 0x0) + 0x0) + 0x0) + 0x0) + 0x30U)))) + (0x1U * 0x4U))) = (W_)R2.w;
*((P_)((*((P_)(_c9y + (((((0x4U + 0x0) + 0x0) + 0x0) + 0x0) + 0x30U)))) + (0x0 * 0x4U))) = (W_)&stg_ut_1_0_unreg_info;
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_c9y = (W_)unblockOne((void *)(*((P_)((_c9u + 0x4U) + 0x0))));
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
*((P_)((_c9u + 0x4U) + 0x0)) = _c9y;
if ((*((P_)((_c9u + 0x4U) + 0x0))) == (W_)&stg_END_TSO_QUEUE_closure) goto _cdC;
goto _cdD;
_cdC:
*((P_)((_c9u + 0x4U) + 0x8U)) = (W_)&stg_END_TSO_QUEUE_closure;
goto _cdD;
_cdD:
goto _cdB;
_cdB:
Sp[-1] = 0x1U;
Sp=Sp-1;
JMP_(*((P_)(Sp[1])));
FE_
}


FN_(makeStableNamezh_fast) {
W_ _c9H;
W_ _c9J;
FB_
Hp = (P_)((W_)Hp + (0x4U + 0x4U));
if ((W_)Hp > (W_)HpLim) goto _cdE;
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_c9H = lookupStableName((void *)(W_)R1.w);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
if ((*((P_)(((*((P_)(W_)&stable_ptr_table)) + (_c9H * 0x10U)) + 0xcU))) == 0x0) goto _cdF;
_c9J = *((P_)(((*((P_)(W_)&stable_ptr_table)) + (_c9H * 0x10U)) + 0xcU));
goto _cdG;
_cdE:
HpAlloc = 0x4U + 0x4U;
R9.p = (P_)(0xffU ^ (0x1U << 0x0));
R10.p = (P_)(W_)&makeStableNamezh_fast;
JMP_((W_)&stg_gc_gen);
_cdF:
_c9J = ((W_)Hp - (0x4U + 0x4U)) + (0x1U * 0x4U);
*((P_)(_c9J)) = (W_)&stg_STABLE_NAME_info;
*((P_)((_c9J + 0x4U) + 0x0)) = _c9H;
*((P_)(((*((P_)(W_)&stable_ptr_table)) + (_c9H * 0x10U)) + 0xcU)) = _c9J;
goto _cdG;
_cdG:
Sp[-1] = _c9J;
Sp=Sp-1;
JMP_(*((P_)(Sp[1])));
FE_
}


FN_(makeStablePtrzh_fast) {
W_ _cdH;
FB_
if ((*((P_)(W_)&alloc_blocks)) >= (*((P_)(W_)&alloc_blocks_lim))) goto _cdI;
goto _cdJ;
_cdI:
R9.p = (P_)(0xffU ^ (0x1U << 0x0));
R10.p = (P_)(W_)&makeStablePtrzh_fast;
JMP_((W_)&stg_gc_gen_hp);
_cdJ:
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_cdH = (W_)getStablePtr((void *)(W_)R1.w);
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
Sp[-1] = _cdH;
Sp=Sp-1;
JMP_(*((P_)(Sp[1])));
FE_
}


FN_(deRefStablePtrzh_fast) {
W_ _c9U;
W_ _c9V;
FB_
_c9U = (W_)R1.w;
_c9V = *((P_)(((*((P_)(W_)&stable_ptr_table)) + (_c9U * 0x10U)) + 0x0));
Sp[-1] = _c9V;
Sp=Sp-1;
JMP_(*((P_)(Sp[1])));
FE_
}


FN_(newBCOzh_fast) {
W_ _c9Z;
W_ _ca2;
W_ _ca3;
W_ _ca4;
W_ _ca7;
FB_
_c9Z = (W_)R6.w;
_ca2 = ((0x4U + 0x14U) / 0x4U) + (*((P_)((_c9Z + 0x4U) + 0x0)));
_ca3 = _ca2 * 0x4U;
Hp = (P_)((W_)Hp + _ca3);
if ((W_)Hp > (W_)HpLim) goto _cdK;
_ca4 = ((W_)Hp - _ca3) + (0x1U * 0x4U);
*((P_)(_ca4)) = (W_)&stg_BCO_info;
*((P_)((_ca4 + 0x4U) + 0x0)) = (W_)R1.w;
*((P_)((_ca4 + 0x4U) + 0x4U)) = (W_)R2.w;
*((P_)((_ca4 + 0x4U) + 0x8U)) = (W_)R3.w;
*((P_)((_ca4 + 0x4U) + 0xcU)) = (W_)R4.w;
*((StgWord16*)((_ca4 + 0x4U) + 0x10U)) = (StgWord16)((W_)R5.w);
*((StgWord16*)((_ca4 + 0x4U) + 0x12U)) = (StgWord16)(_ca2);
_ca7 = 0x0;
goto _L2A;
_cdK:
HpAlloc=_ca3;
R9.p = (P_)(((((0xffU ^ (0x1U << 0x0)) & (0xffU ^ (0x1U << 0x1U))) & (0xffU ^ (0x1U << 0x2U))) & (0xffU ^ (0x1U << 0x3U))) & (0xffU ^ (0x1U << 0x5U)));
R10.p = (P_)(W_)&newBCOzh_fast;
JMP_((W_)&stg_gc_gen);
_L2A:
if (_ca7 < (*((P_)((_c9Z + 0x4U) + 0x0)))) goto _cdL;
goto _cdM;
_cdL:
*((P_)(((_ca4 + 0x4U) + 0x14U) + (_ca7 * 0x4U))) = *((P_)(((_c9Z + 0x4U) + 0x4U) + (_ca7 * 0x4U)));
_ca7 = _ca7 + 0x1U;
goto _L2A;
_cdM:
Sp[-1] = _ca4;
Sp=Sp-1;
JMP_(*((P_)(Sp[1])));
FE_
}


FN_(mkApUpd0zh_fast) {
W_ _cac;
FB_
Hp = (P_)((W_)Hp + (0x4U + 0x8U));
if ((W_)Hp > (W_)HpLim) goto _cdN;
_cac = ((W_)Hp - (0x4U + 0x8U)) + (0x1U * 0x4U);
*((P_)(_cac)) = (W_)&stg_AP_info;
*((StgWord16*)((_cac + 0x4U) + 0x2U)) = (StgWord16)(0x0);
*((P_)((_cac + 0x4U) + 0x4U)) = (W_)R1.w;
Sp[-1] = _cac;
Sp=Sp-1;
JMP_(*((P_)(Sp[1])));
_cdN:
HpAlloc = 0x4U + 0x8U;
R9.p = (P_)(0xffU ^ (0x1U << 0x0));
R10.p = (P_)(W_)&mkApUpd0zh_fast;
JMP_((W_)&stg_gc_gen);
FE_
}


FN_(waitReadzh_fast) {
FB_
*((StgWord16*)(((W_)CurrentTSO + 0x4U) + 0xeU)) = 0x4U;
*((P_)(((W_)CurrentTSO + 0x4U) + 0x10U)) = (W_)R1.w;
if ((*((P_)(W_)&blocked_queue_hd)) == (W_)&END_TSO_QUEUE) goto _cdO;
*((P_)(((*((P_)(W_)&blocked_queue_tl)) + 0x4U) + 0x0)) = (W_)CurrentTSO;
goto _cdP;
_cdO:
*((P_)(W_)&blocked_queue_hd) = (W_)CurrentTSO;
goto _cdP;
_cdP:
*((P_)(W_)&blocked_queue_tl) = (W_)CurrentTSO;
JMP_((W_)&stg_block_noregs);
FE_
}


FN_(waitWritezh_fast) {
FB_
*((StgWord16*)(((W_)CurrentTSO + 0x4U) + 0xeU)) = 0x5U;
*((P_)(((W_)CurrentTSO + 0x4U) + 0x10U)) = (W_)R1.w;
if ((*((P_)(W_)&blocked_queue_hd)) == (W_)&END_TSO_QUEUE) goto _cdQ;
*((P_)(((*((P_)(W_)&blocked_queue_tl)) + 0x4U) + 0x0)) = (W_)CurrentTSO;
goto _cdR;
_cdQ:
*((P_)(W_)&blocked_queue_hd) = (W_)CurrentTSO;
goto _cdR;
_cdR:
*((P_)(W_)&blocked_queue_tl) = (W_)CurrentTSO;
JMP_((W_)&stg_block_noregs);
FE_
}

char stg_delayzh_malloc_str[] = "delayzh_fast";


FN_(delayzh_fast) {
W_ _cap;
W_ _caq;
W_ _car;
W_ _cas;
FB_
*((StgWord16*)(((W_)CurrentTSO + 0x4U) + 0xeU)) = 0x6U;
CALLER_SAVE_USER
CALLER_SAVE_SYSTEM
_cap = getourtimeofday();
CALLER_RESTORE_SYSTEM
CALLER_RESTORE_USER
_caq = ((W_)R1.w / ((0x3e8U / 0x32U) * 0x3e8U)) + _cap;
*((P_)(((W_)CurrentTSO + 0x4U) + 0x10U)) = _caq;
_car = 0x0;
_cas = *((P_)(W_)&sleeping_queue);
goto _L75;
_L75:
if (_cas != (W_)&END_TSO_QUEUE) goto _cdV;
goto _cdX;
_cdV:
if ((*((P_)((_cas + 0x4U) + 0x10U))) < _caq) goto _cdY;
goto _cdX;
_cdX:
goto _cdZ;
_cdY:
_car=_cas;
_cas = *((P_)((_cas + 0x4U) + 0x0));
goto _L75;
_cdZ:
*((P_)(((W_)CurrentTSO + 0x4U) + 0x0)) = _cas;
if (_car == 0x0) goto _ce1;
*((P_)((_car + 0x4U) + 0x0)) = (W_)CurrentTSO;
goto _ce3;
_ce1:
*((P_)(W_)&sleeping_queue) = (W_)CurrentTSO;
goto _ce3;
_ce3:
JMP_((W_)&stg_block_noregs);
FE_
}

StgWord GHC_ZCCCallable_static_info[] = {
0x0
};

StgWord GHC_ZCCReturnable_static_info[] = {
0x0
};
